#include <os.h>
#include "disp.h"
//thanks to the person who has written the routines these here are based on
//unfortunately I didn't find out who it was


inline void setPixelBuf(uint8_t* scrbuf, unsigned short x, unsigned short y, uint8_t color){
	uint8_t* p = scrbuf + ((x >> 1) + (y << 7) + (y << 5));
	if(x < SCREEN_WIDTH && y < SCREEN_HEIGHT)
		*p = (x & 1) ? ((*p & 0xF0) | color) : ((*p & 0x0F) | (color << 4));
}

void putChar(uint8_t* scrbuf, unsigned short x, unsigned short y, char chr){
	int i, j, pixelOn;
	for(i = 0; i < CHAR_HEIGHT; i++)
	{
		for(j = 0; j < CHAR_WIDTH; j++)
		{
			pixelOn = charMap_ascii[chr][i] << j ;
			pixelOn = pixelOn & 0x80 ;
			if (pixelOn) {
				setPixelBuf(scrbuf, x + j, y + i, 0);
			} else {
				setPixelBuf(scrbuf, x + j, y + i, 15);
			}
		}
	}
}

void dispString(uint8_t* scrbuf, unsigned short x, unsigned short y, char* message){
	int32_t l = strlen(message);
	int32_t i;
	uint16_t line=0, col=0;
	for (i = 0; i<l; i++){
	    if(message[i] == '\n'){
	        col = 0;
	        ++line;
	    }
	    else if(message[i] == '\t'){
	        col += CHAR_WIDTH * (TAB_WIDTH - (((x+col) / CHAR_WIDTH) % TAB_WIDTH));
	    }
	    else{
            putChar(scrbuf, x+col*CHAR_WIDTH, y+line*CHAR_HEIGHT, message[i]);
            ++col;
	    }
		if (x+col*CHAR_WIDTH >= SCREEN_WIDTH){
			col = 0;
			++line;
		}
		if(y + line*CHAR_HEIGHT >= SCREEN_HEIGHT)//damit nicht speicher hinter screenbuffer berschrieben wird
			break;
	}
}
